package extThopt;

import extThopt.*;
import java.util.*; 
import rg.corps.*; 
import rg.thopt.*; 
/**
* This class is an example of an external mixture for Thermoptim.
*<p>This class may be modified under the CeCILL copyright

Copyright Renaud GICQUEL 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
 * 
 * @author Renaud GICQUEL
*/

public class EauSalee extends ExtSubstance 
{
	private static java.util.ResourceBundle resInt_fr = java.util.ResourceBundle.getBundle("IntTh",Locale.getDefault());  
    
    Corps eau;
    boolean isCreated=false;
    public EauSalee(){//throws Exception{
        super();
        type=getType();
        M=18.01528;PC=221.2;TC=647.3;
        Tmini=273.15;Tmaxi=1073.15;
	    Pmaxi=1000.;
        chemForm="H2O-NaCl mixture";
        typeCorps=6;//corps externe de type isMixture
  	    vMixtures= new Vector();
    }
    
    public String getType(){
        return "eau sale";
    }
    
	public double getSatPressure(double T, double x){
	    if(!isCreated){
            Object obj=Corps.createSubstance(resInt_fr.getString("eau"));
            eau=(Corps)obj;
            isCreated=true;
        }
	    double P=eau.getSatPressure(T-getDelay(x),0);
	    return P;
	}
	public double getSatTemperature(double P, double x){
	    if(!isCreated){
            Object obj=Corps.createSubstance(resInt_fr.getString("eau"));
            eau=(Corps)obj;
        }
	    double T=eau.getSatTemperature(P,0);
	    double delay=getDelay(x);
	    return T+delay;
	}
	
	double getDelay(double x){
	    return 11.02546*x+67.0079*x*x;
	}
    
	public double calcV (double T, double P,double x) {
	    if(!isCreated){
            Object obj=Corps.createSubstance(resInt_fr.getString("eau"));
            eau=(Corps)obj;
        }
        eau.CalcPropCorps(T-getDelay(x)-0.01,P,0);
        return eau.getState()[3];
	}
	public double calcS (double T, double P,double x) {
	    if(!isCreated){
            Object obj=Corps.createSubstance(resInt_fr.getString("eau"));
            eau=(Corps)obj;
        }
        eau.CalcPropCorps(T-getDelay(x)-0.01,P,0);
        return eau.getState()[6];
	}
		public double calcXx (double T, double P,double x) {
	    return x;
	}

	public double calcH (double T, double P,double x) {
	    if(!isCreated){
            Object obj=Corps.createSubstance(resInt_fr.getString("eau"));
            eau=(Corps)obj;
        }
        eau.CalcPropCorps(T-getDelay(x)-0.01,P,0);
        return eau.getState()[5];
	}



}